*  TEST6809.SRC - TEST FILE FOR 6809 DISASSEMBLER
*
*  12-FEB-93 BY JOHN HARTMAN
*
*	ORG	0
	
NN	EQU	$12
MMMM	EQU	$1234

QN      NEG         NN          //00
*       undefined         	//01
*       undefined         	//02
        COM         NN        	//03
        LSR         NN        	//04
*       undefined         	//05
        ROR         NN        	//06
        ASR         NN        	//07
        ASL         NN        	//08
        ROL         NN        	//09
        DEC         NN        	//0A
*       undefined         	//0B
        INC         NN        	//0C
        TST         NN        	//0D
        JMP         NN    	//0E
        CLR         NN        	//0F

        NOP               	//12
        SYNC              	//13
*       undefined         	//14
*       undefined         	//15
        LBRA         MMMM   	//16
        LBSR         MMMM 	//17
*       undefined         	//18
        DAA               	//19
        ORCC         #1       	//1A
*       undefined      		//1B
        ANDCC        #$0FF      //1C
        SEX               	//1D
        EXG          X,U	//1E
        TFR          A,B       	//1F

	BRA	    QN		//20
	BRN	    QN		//21
	BHI	    QN		//22
	BLS	    QN		//23
	BCC	    QN		//24
	BCS	    QN		//25
	BNE	    QN		//26
	BEQ	    QN		//27
	BVC	    QF		//28
	BVS	    QF		//29
	BPL	    QF		//2A
	BMI	    QF		//2B
	BGE	    QF		//2C
	BLT	    QF		//2D
	BGT	    QF		//2E
	BLE	    QF		//2F

QF      LEAX         0,Y      	//30
        LEAY         0,U      	//31
        LEAS         0,S      	//32
        LEAU         0,X      	//33
        PSHS         A,B,X      //34
        PULS         PC,D,U     //35
	PSHU	     A,B,DP,X,Y,S,PC	  //36
        PULU         DP		//37
*       undefined         	//38
        RTS         	  	//39
        ABX               	//3A
        RTI               	//3B
        CWAI        #$55        //3C
        MUL               	//3D
*       undefined         	//3E
        SWI               	//3F

        NEGA              	//40
*       undefined         	//41
*       undefined         	//42
        COMA              	//43
        LSRA              	//44
*       undefined         	//45
        RORA              	//46
        ASRA              	//47
        ASLA              	//48
        ROLA              	//49
        DECA              	//4A
*       undefined         	//4B
        INCA              	//4C
        TSTA              	//4D
*       undefined         	//4E
        CLRA              	//4F

        NEGB              	//50
*       undefined         	//51
*       undefined         	//52
        COMB              	//53
        LSRB              	//54
*       undefined         	//55
        RORB              	//56
        ASRB              	//57
        ASLB              	//58
        ROLB              	//59
        DECB              	//5A
*       undefined         	//5B
        INCB              	//5C
        TSTB              	//5D
*       undefined         	//5E
        CLRB              	//5F

        NEG         0,X       	//60
*       undefined         	//61
*       undefined         	//62
        COM         1,X   	//63
        LSR         -1,X       	//64
*       undefined         	//65
        ROR         $0F,X       //66
        ASR         -$0F,X      //67
        ASL         $10,X       //68
        ROL         -$10,X      //69
        DEC         $7F,X       //6A
*       undefined         	//6B
        INC         -$7F,X      //6C
        TST         $100,X      //6D
        JMP         -$100,X     //6E
        CLR         $7000,X     //6F

        NEG         MMMM      	//70
*       undefined         	//71
*       undefined         	//72
        COM         MMMM        //73
        LSR         MMMM      	//74
*       undefined         	//75
        ROR         MMMM        //76
        ASR         MMMM      	//77
        ASL         MMMM      	//78
        ROL         MMMM      	//79
        DEC         MMMM      	//7A
*       undefined         	//7B	
        INC         MMMM      	//7C
        TST         MMMM      	//7D
        JMP         MMMM  	//7E
        CLR         MMMM      	//7F

        SUBA         #NN   	//80
        CMPA         #NN   	//81
        SBCA         #NN   	//82
        SUBD         #MMMM   	//83
        ANDA         #NN   	//84
        BITA         #NN   	//85
        LDA          #NN   	//86
*       undefined         	//87
        EORA         #NN   	//88
        ADCA         #NN   	//89
        ORA          #NN   	//8A
QQB     ADDA         #NN   	//8B
        CMPX         #MMMM   	//8C
	BSR	     QQB	//8D
        LDX          #MMMM  	//8E
*       undefined         	//8F

        SUBA         NN       	//90
        CMPA         NN       	//91
        SBCA         NN       	//92
        SUBD         NN       	//93
        ANDA         NN       	//94
        BITA         NN       	//95
        LDA          NN       	//96
        STA          NN       	//97
        EORA         NN       	//98
        ADCA         NN       	//99
        ORA          NN       	//9A
        ADDA         NN       	//9B
        CMPX         NN       	//9C
        JSR          NN   	//9D	
        LDX          NN       	//9E
        STX          NN       	//9F

        SUBA         ,Y+      	//A0
        CMPA         ,Y++       //A1
        SBCA         ,-Y      	//A2
        SUBD         ,--Y     	//A3
        ANDA         NN,PCR     //A4
        BITA         MMMM,PCR   //A5
        LDA          A,Y     	//A6
        STA          B,Y     	//A7
        EORA         D,Y      	//A8
        ADCA         [0,U]      //A9
        ORA          [NN,U]     //AA
        ADDA         [MMMM,U]   //AB
        CMPX         [MMMM]     //AC
	JSR	     [,U++]	 //AD
        LDX          [,U++]     //AE
	STX	     [,--U]	 //AF

        SUBA         MMMM     //B0
        CMPA         MMMM     //B1
        SBCA         MMMM     //B2
        SUBD         MMMM     //B3
        ANDA         MMMM     //B4
        BITA         MMMM     //B5
        LDA          MMMM     //B6
        STA          MMMM     //B7
        EORA         MMMM     //B8
        ADCA         MMMM     //B9
        ORA          MMMM     //BA
        ADDA         MMMM     //BB
        CMPX         MMMM     //BC
        JSR          MMMM     //BD
        LDX          MMMM     //BE
        STX          MMMM     //BF

        SUBB         #NN   	//C0
        CMPB         #NN   	//C1
        SBCB         #NN   	//C2
        ADDD         #MMMM  	//C3
        ANDB         #NN   	//C4
        BITB         #NN   	//C5
        LDB         #NN    	//C6
        EORB         #NN   	//C8
        ADCB         #NN   	//C9
        ORB         #NN    	//CA
        ADDB         #NN   	//CB
        LDD          #MMMM 	//CC
        LDU          #MMMM  	//CE

        SUBB         NN       //D0
        CMPB         NN       //D1
        SBCB         NN       //D2
        ADDD         NN       //D3
        ANDB         NN       //D4
        BITB         NN       //D5
        LDB          NN       //D6
        STB          NN       //D7
        EORB         NN       //D8
        ADCB         NN       //D9
        ORB          NN       //DA
        ADDB         NN       //DB
        LDD          NN       //DC
        STD          NN       //DD
        LDU          NN       //DE
        STU          NN       //DF

        SUBB         0,X      //E0
        CMPB         0,X      //E1
        SBCB         0,X      //E2
        ADDD         0,X      //E3
        ANDB         0,X      //E4
        BITB         0,X      //E5
        LDB          0,X      //E6
        STB          0,X      //E7
        EORB         0,X      //E8
        ADCB         0,X      //E9
        ORB          0,X      //EA
        ADDB         0,X      //EB
        LDD          0,X      //EC
        STD          0,X      //ED
        LDU          0,X      //EE
        STU          0,X      //EF

        SUBB         MMMM     //F0
        CMPB         MMMM     //F1
        SBCB         MMMM     //F2
        ADDD         MMMM     //F3
        ANDB         MMMM     //F4
        BITB         MMMM     //F5
        LDB          MMMM     //F6
        STB          MMMM     //F7
        EORB         MMMM     //F8
        ADCB         MMMM     //F9
        ORB          MMMM     //FA
        ADDB         MMMM     //FB
        LDD          MMMM     //FC
        STD          MMMM     //FD
        LDU          MMMM     //FE
        STU          MMMM     //FF

        LBRA         MMMM   //20
        LBRN         QN     //21
        LBHI         MMMM   //22
        LBLS         MMMM   //23
        LBCC         MMMM   //24
        LBCS         MMMM   //25
        LBNE         MMMM   //26
        LBEQ         MMMM   //27
        LBVC         MMMM   //28
        LBVS         MMMM   //29
        LBPL         MMMM   //2A
        LBMI         MMMM   //2B
        LBGE         MMMM   //2C
        LBLT         MMMM   //2D
        LBGT         MMMM   //2E
        LBLE         QN     //2F

        SWI2              //3F

        CMPD         #MMMM  //83
        CMPY         #MMMM  //8C
        LDY          #MMMM  //8E

        CMPD         NN       //93
        CMPY         NN       //9C
        LDY         NN        //9E
        STY         NN        //9F

        CMPD         0,X      //A3
        CMPY         0,X      //AC
        LDY         0,X       //AE
        STY         0,X       //AF

        CMPD         MMMM     //B3
        CMPY         MMMM     //BC
        LDY         MMMM      //BE
        STY         MMMM      //BF
        LDS         #MMMM   //CE
        LDS         NN        //DE
        STS         NN        //DF

        LDS         0,X       //EE
        STS         0,X       //EF

        LDS         MMMM      //FE
        STS         MMMM      //FF

        SWI3              //3F

        CMPU         #MMMM  //83
        CMPS         #MMMM  //8C
        CMPU         NN       //93
        CMPS         NN       //9C
        CMPU         0,X      //A3
        CMPS         0,X      //AC
        CMPU         MMMM     //B3
        CMPS         MMMM     //BC

	LDA	#NN
	LDA	NN
	LDA	MMMM
*
*  indexed
	LDA	0,X
	LDA	0,Y
	LDA	0,U
	LDA	0,S
	LDA	1,X
	LDA	NN,X
	LDA	MMMM,X
	LDA	,X+
	LDA	,X++
	LDA	,-X
	LDA	,--X
	LDA	A,X
	LDA	B,X
	LDA	D,X
	LDA	NN,PCR
	LDA	MMMM,PCR
*
*  indexed indirect
        LDA     [MMMM]
        LDA     [0,X]
        LDA     [0,Y]
        LDA     [0,U]
        LDA     [0,S]
        LDA     [1,X]
        LDA     [NN,X]
	LDA	[MMMM,X]
	LDA	[,X++]
        LDA     [,--X]
        LDA     [A,X]
        LDA     [B,X]
        LDA     [D,X]
        LDA     [NN,PCR]
        LDA     [MMMM,PCR]
*
*  Try all TFR registers
	TFR	A,B
	TFR	B,DP
	TFR	CC,A

	TFR	X,Y
	TFR	U,S
	TFR	PC,D
*
*  Test subroutine call address modes
	JSR	TSUB
	BSR	TSUB
	LDX	#TSUB
	JSR	,X
	LDX	#T1
	JSR	2,X
	JSR	[T1]
	JSR	[,X]
	JSR	[,X++]
	JSR	[,--X]
*
	JSR	TS2		;TRY RTI
	JSR	TS3		;TRY PULS
*
T1	FDB	TSUB
TSUB	INCA
	RTS
*
TS2	PSHS	U,Y,X,DP,B,A,CC
	RTI
*
TS3	PSHS	A
	PULS	PC,B

*  Long instruction
        CMPD    -MMMM,S
        LDY     MMMM,X

	END
